
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <unistd.h>
#include <pwd.h>

static int scounter = 0;
static sigset_t set, oset;

qnx_masksignal()
{
	int i, ern;

	ern = errno;
	if ( scounter==0 )
		{
	    sigemptyset( &set );

		for ( i=0; i<32; i++ )
		    sigaddset( &set, i );

	    sigprocmask( SIG_BLOCK, &set, &oset );
		}
	errno = ern;

	scounter++;
}

qnx_unmasksignal()
{
	int ern = errno;

	scounter--;

	if ( scounter <= 0 )
	   sigprocmask( SIG_UNBLOCK, &set, &oset );
	   /* if signal pending, the process is signaled
		  before sigprocmask() return */

	errno = ern;
}

struct	spwd {
	char	*sp_namp;
	char	*sp_pwdp;
	long	sp_lstchg;
	long	sp_max;
	long	sp_min;
};

#define	FIELDS	5

int parse_sp(char *buf, struct spwd *sp)
{
	char *fields[FIELDS];
	char *cp;
	char *cpp;
	int	i;

	if (cp = strrchr (buf, '\n'))
		*cp = '\0';

	for (cp = buf, i = 0;*cp && i < FIELDS;i++) {
		fields[i] = cp;
		while (*cp && *cp != ':')
			cp++;

		if (*cp)
			*cp++ = '\0';
	}
	if (*cp || i != FIELDS)
		return 0;

	sp->sp_namp = fields[0];
	sp->sp_pwdp = fields[1];

	if ((sp->sp_lstchg = strtol (fields[2], &cpp, 10)) == 0 && *cpp)
		return 0;
	if ((sp->sp_min = strtol (fields[3], &cpp, 10)) == 0 && *cpp)
		return 0;
	if ((sp->sp_max = strtol (fields[4], &cpp, 10)) == 0 && *cpp)
		return 0;
	return 1;
}

static	char	buf[BUFSIZ];
static	struct	spwd	spwd;

struct spwd	*getspnam(char *name)
{
	FILE	*f;
	int		found = 0;

	if ((f=fopen("/etc/shadow","r")) == NULL)
		return NULL;

	while (fgets(buf,sizeof(buf)-1,f)) {
		if (parse_sp(buf,&spwd)) {
			if ((found=!strcmp(spwd.sp_namp,name)))
				break;
		}
	}
	fclose( f );

	return found ? &spwd : NULL;
}

static FILE *fmdebug = NULL;

void qdebug( char *fmt, ... )
{
	va_list arglist;

	long clk = time(NULL);
	struct tm *st = localtime( &clk );

	qnx_masksignal();

	if ( fmdebug == NULL )
		fmdebug = fopen( "/tmp/memory.dbg", "a" );

	fprintf( fmdebug, "%02d/%02d/%02d %02d:%02d:%02d ",
		st->tm_mday, st->tm_mon+1, st->tm_year,
		st->tm_hour, st->tm_min, st->tm_sec );
	va_start( arglist, fmt );
	vfprintf( fmdebug, fmt, arglist);
	va_end( arglist );
	fprintf( fmdebug, "\n" );
	fflush( fmdebug );

	qnx_unmasksignal();
}
