/*  $Revision: 1.2 $
**
*/
#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>
#include "configdata.h"
#include "clibrary.h"
#include "nnrpd.h"
#if	NNRP_LOADLIMIT > 0

#if defined(__QNX__)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/kernel.h>
#include <sys/osinfo.h>
#include <sys/psinfo.h>
#include <sys/sidinfo.h>
#include <sys/kernel.h>

/* Return the number of nnrpd running or 1024 if there's
   less than 2 Mb of free memory */

int GetLoadAverage()
{
	int id, nnrpd=0;
	struct _psinfo	pdata;
	struct _osinfo	osdata;
	char *p;

	id = 1;
	while( (id = qnx_psinfo( 0, id, &pdata, 0, NULL )) != -1 )
		{
		id++;
		if ( strstr( pdata.un.proc.name, "nnrpd" ) != NULL ) 
			nnrpd++;
		}

	/* if there's less than 2 Mb of free memory, LA is to high */
	if ( qnx_osinfo( getnid(), &osdata ) != -1 )
		{
		long unsigned freepmem, totpmem;

		freepmem = osdata.freepmem;
		if ( (totpmem = osdata.totpmem) == 0 )
			{
			totpmem  = osdata.totmemk  * 1000L;
			freepmem = osdata.freememk * 1000L;
			}

		if ( (freepmem/1000L) < 2048 )
			return( 1024 );
		}

	return( nnrpd );
}

#elif linux
/*
**  Get the current load average as an integer.
*/
int
GetLoadAverage()
{
    FILE *ProcLoadAve;
    float load;

    if ((ProcLoadAve=fopen("/proc/loadavg", "r"))==NULL)
        return -1;
    if (fscanf(ProcLoadAve,"%f", &load)!=1)
    	return -1;
    fclose(ProcLoadAve);
    return (int)(load+0.5);
}

#else 
#include <nlist.h>
STATIC struct nlist NameList[] = {
    { "_avenrun" },
#define	X_AVENRUN	0
    { NULL }
};


/*
**  Get the current load average as an integer.
*/
int
GetLoadAverage()
{
    int		fd;
    int		oerrno;
#if	defined(FSCALE)
    long	avenrun[3];
#else
    double	avenrun[3];
#endif	/* defined(FSCALE) */

    fd = open("/dev/kmem", 0, 0);
    if (fd < 0)
	return -1;

#if	defined(HPUX)
    (void)nlist("/hp-ux", NameList);
#else
#if	defined(SUNOS5)
    (void)nlist("/dev/ksyms", NameList);
#else
    (void)nlist("/vmunix", NameList);
#endif	/* defined(SUNOS5) */
#endif	/* !defined(HPUX) */
    if (NameList[0].n_type == 0
     || lseek(fd, (OFFSET_T) NameList[X_AVENRUN].n_value, SEEK_SET) == -1
     || read(fd, (char *)avenrun, sizeof avenrun) != sizeof avenrun) {
	oerrno = errno;
	(void)close(fd);
	errno = oerrno;
	return -1;
    }

    (void)close(fd);

#if	defined(FSCALE)
    return (int)(avenrun[0] + FSCALE / 2) >> FSHIFT;
#else
    return (int)(avenrun[0] + 0.5);
#endif	/* defined(FSCALE) */
}
#endif /* linux */

#endif	/* NNRP_LOADLIMIT > 0 */
